var it = Object.defineProperty;
var nt = (r, t, e) => t in r ? it(r, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[t] = e;
var P = (r, t, e) => (nt(r, typeof t != "symbol" ? t + "" : t, e), e), ge = (r, t, e) => {
  if (!t.has(r))
    throw TypeError("Cannot " + e);
};
var d = (r, t, e) => (ge(r, t, "read from private field"), e ? e.call(r) : t.get(r)), L = (r, t, e) => {
  if (t.has(r))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(r) : t.set(r, e);
}, W = (r, t, e, s) => (ge(r, t, "write to private field"), s ? s.call(r, e) : t.set(r, e), e);
var we = (r, t, e) => (ge(r, t, "access private method"), e);
import Be, { spawnSync as ot } from "node:child_process";
import { constants as Y, lstat as te, mkdir as ut, chmod as ct, unlink as lt } from "node:fs/promises";
import { join as Le, resolve as Me } from "node:path";
import ft from "fs";
import pt from "path";
import ht from "util";
import { randomBytes as mt } from "node:crypto";
const B = globalThis.process ?? { env: {}, versions: {} }, se = { ...B == null ? void 0 : B.env }, dt = {
  // eslint-disable-next-line @typescript-eslint/ban-ts-comment
  // @ts-ignore
  node: "unknown",
  ...B == null ? void 0 : B.versions
}, Oe = (B == null ? void 0 : B.platform) ?? "unknown", ue = (B == null ? void 0 : B.arch) ?? "unknown";
class v extends Error {
  constructor(e, s) {
    super(e);
    P(this, "code");
    P(this, "stack");
    P(this, "context");
    this.context = s, s instanceof Error && (this.name = s.name, this.stack = s.stack, "code" in s && typeof s.code == "string" && (this.code = s.code));
  }
}
const gt = [
  {
    url: "{scheme}://{host}{basePath}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api.browserstack.com"
      },
      basePath: {
        default: "/5"
      }
    }
  },
  {
    url: "{scheme}://{host}",
    variables: {
      scheme: {
        default: "https"
      },
      host: {
        default: "api-cloud.browserstack.com"
      }
    }
  }
], wt = "browserstack-client", vt = "3.0.0-next.12", kt = "BrowserStack APIs client library for node.js", yt = "module", St = "./dist/browserstack-client.umd.cjs", xt = {
  "browserstack-local": "./dist/node/browserstack-local.cjs"
}, Rt = "./dist/browserstack-client.js", bt = "./dist/types/index.d.ts", It = {
  ".": {
    types: "./dist/types/index.d.ts",
    import: "./dist/browserstack-client.js",
    require: "./dist/browserstack-client.umd.cjs"
  },
  "./node": {
    types: "./dist/node/types/index.node.d.ts",
    import: "./dist/node/browserstack-client.js",
    require: "./dist/node/browserstack-client.cjs"
  },
  "./package.json": "./package.json",
  "./*": "./dist/*"
}, qt = {
  prebuild: "node build.mjs && npm run lint",
  build: "tsc && vite build && vite build --config vite.config.node.ts",
  test: "vitest run --typecheck",
  "test-watch": "vitest --typecheck",
  coverage: "vitest run --coverage.enabled --coverage.include=src --coverage.exclude=src/generated",
  lint: "eslint . --ext .ts",
  "predocs:dev": "typedoc",
  "docs:dev": "vitepress dev docs",
  "predocs:build": "typedoc",
  "docs:build": "vitepress build docs",
  "docs:preview": "vitepress preview docs"
}, At = "Shirish Kamath", jt = "MIT", Et = [
  "dist/**/*",
  "*.d.ts"
], _t = {
  node: ">=18.0.0"
}, Pt = {
  "@apidevtools/swagger-parser": "^10.1.0",
  "@types/node": "^20.11.6",
  "@types/write-file-atomic": "^4.0.3",
  "@typescript-eslint/eslint-plugin": "^6.19.1",
  "@typescript-eslint/parser": "^6.19.1",
  "@vitest/coverage-v8": "^1.2.1",
  eslint: "^8.56.0",
  "openapi-typescript": "^7.0.0-next.7",
  "openapi-typescript-helpers": "^0.0.5",
  typedoc: "^0.25.7",
  "typedoc-plugin-markdown": "^4.0.0-next.43",
  "typedoc-vitepress-theme": "^1.0.0-next.0",
  typescript: "^5.2.2",
  vite: "^5.0.8",
  "vite-plugin-dts": "^3.7.2",
  vitepress: "^1.0.0-rc.40",
  vitest: "1.2.1"
}, Ct = {
  fflate: "^0.8.2",
  "openapi-fetch": "^0.8.2",
  "write-file-atomic": "^5.0.1"
}, Tt = {
  type: "git",
  url: "git://github.com/shirish87/browserstack-client.git"
}, Gt = "https://shirish87.github.io/browserstack-client/", Dt = {
  url: "https://github.com/shirish87/browserstack-client/issues"
}, Bt = [
  "browserstack",
  "api",
  "client",
  "node",
  "javascript",
  "typescript",
  "esm"
], D = {
  name: wt,
  version: vt,
  description: kt,
  type: yt,
  main: St,
  bin: xt,
  module: Rt,
  types: bt,
  exports: It,
  scripts: qt,
  author: At,
  license: jt,
  files: Et,
  engines: _t,
  devDependencies: Pt,
  dependencies: Ct,
  repository: Tt,
  homepage: Gt,
  bugs: Dt,
  keywords: Bt
}, Ot = [D == null ? void 0 : D.name, D == null ? void 0 : D.version].filter(Boolean).join("/"), $t = ["node", dt.node].filter(Boolean).join("/"), Ut = [Ot, $t].filter(Boolean).join(" "), Lt = {
  name: D == null ? void 0 : D.name,
  version: D == null ? void 0 : D.version,
  userAgent: Ut
}, Mt = {
  "Content-Type": "application/json"
};
function $e(r) {
  const {
    fetch: t = globalThis.fetch,
    querySerializer: e,
    bodySerializer: s,
    ...a
  } = r ?? {};
  let i = a.baseUrl ?? "";
  i.endsWith("/") && (i = i.slice(0, -1));
  async function n(c, o) {
    const {
      fetch: l = t,
      headers: h,
      body: u,
      params: f = {},
      parseAs: k = "json",
      querySerializer: w = e ?? zt,
      bodySerializer: m = s ?? Ft,
      ...I
    } = o || {}, x = Ht(c, {
      baseUrl: i,
      params: f,
      querySerializer: w
    }), A = Kt(
      Mt,
      r == null ? void 0 : r.headers,
      h,
      f.header
    ), S = {
      redirect: "follow",
      ...a,
      ...I,
      headers: A
    };
    u && (S.body = m(u)), S.body instanceof FormData && A.delete("Content-Type");
    const y = await l(x, S);
    if (y.status === 204 || y.headers.get("Content-Length") === "0")
      return y.ok ? { data: {}, response: y } : { error: {}, response: y };
    if (y.ok) {
      if (k === "stream")
        return { data: y.clone().body, response: y };
      const j = y.clone();
      return {
        data: typeof j[k] == "function" ? await j[k]() : await j.text(),
        response: y
      };
    }
    let U = {};
    try {
      U = await y.clone().json();
    } catch {
      U = await y.clone().text();
    }
    return { error: U, response: y };
  }
  return {
    /** Call a GET endpoint */
    async GET(c, o) {
      return n(c, { ...o, method: "GET" });
    },
    /** Call a PUT endpoint */
    async PUT(c, o) {
      return n(c, { ...o, method: "PUT" });
    },
    /** Call a POST endpoint */
    async POST(c, o) {
      return n(c, { ...o, method: "POST" });
    },
    /** Call a DELETE endpoint */
    async DELETE(c, o) {
      return n(c, { ...o, method: "DELETE" });
    },
    /** Call a OPTIONS endpoint */
    async OPTIONS(c, o) {
      return n(c, { ...o, method: "OPTIONS" });
    },
    /** Call a HEAD endpoint */
    async HEAD(c, o) {
      return n(c, { ...o, method: "HEAD" });
    },
    /** Call a PATCH endpoint */
    async PATCH(c, o) {
      return n(c, { ...o, method: "PATCH" });
    },
    /** Call a TRACE endpoint */
    async TRACE(c, o) {
      return n(c, { ...o, method: "TRACE" });
    }
  };
}
function zt(r) {
  const t = [];
  if (r && typeof r == "object")
    for (const [e, s] of Object.entries(r)) {
      const a = xe([e], s);
      a && t.push(a);
    }
  return t.join("&");
}
function xe(r, t) {
  if (t != null) {
    if (typeof t == "string")
      return `${ve(r)}=${encodeURIComponent(t)}`;
    if (typeof t == "number" || typeof t == "boolean")
      return `${ve(r)}=${String(t)}`;
    if (Array.isArray(t)) {
      if (!t.length)
        return;
      const e = [];
      for (const s of t) {
        const a = xe(r, s);
        a !== void 0 && e.push(a);
      }
      return e.join("&");
    }
    if (typeof t == "object") {
      if (!Object.keys(t).length)
        return;
      const e = [];
      for (const [s, a] of Object.entries(t))
        if (a != null) {
          const i = xe([...r, s], a);
          i !== void 0 && e.push(i);
        }
      return e.join("&");
    }
    return encodeURIComponent(`${ve(r)}=${String(t)}`);
  }
}
function ve(r) {
  let t = r[0];
  for (const e of r.slice(1))
    t += `[${e}]`;
  return t;
}
function Ft(r) {
  return JSON.stringify(r);
}
function Ht(r, t) {
  let e = `${t.baseUrl}${r}`;
  if (t.params.path)
    for (const [a, i] of Object.entries(t.params.path))
      e = e.replace(`{${a}}`, encodeURIComponent(String(i)));
  const s = t.querySerializer(t.params.query ?? {});
  return s && (e += `?${s}`), e;
}
function Kt(...r) {
  const t = new Headers();
  for (const e of r) {
    if (!e || typeof e != "object")
      continue;
    const s = e instanceof Headers ? e.entries() : Object.entries(e);
    for (const [a, i] of s)
      i === null ? t.delete(a) : i !== void 0 && t.set(a, i);
  }
  return t;
}
const [{ variables: ce }, { variables: le }] = gt ?? [], Nt = `${ce.scheme.default}://${ce.host.default}${ce.basePath ? ce.basePath.default : ""}`, Wt = `${le.scheme.default}://${le.host.default}${le.basePath ? le.basePath.default : ""}`;
class re {
  constructor(t) {
    P(this, "sdk");
    P(this, "sdkCloud");
    const e = t.username ?? se.BROWSERSTACK_USERNAME;
    if (t.usernameOptional !== !0 && (typeof e != "string" || !e.trim().length))
      throw new v("Missing options.username");
    const s = t.key ?? se.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new v("Missing options.key");
    const a = {
      ...t,
      baseUrl: t.baseUrl ?? Nt,
      headers: {
        ...t.headers,
        Authorization: e ? `Basic ${btoa(`${e}:${s}`)}` : void 0,
        "User-Agent": Lt.userAgent
      }
    };
    this.sdk = $e(a), this.sdkCloud = $e({
      ...a,
      baseUrl: Wt
    });
  }
  /**
   * @internal
   */
  async makeGetRequest(t, ...e) {
    const s = await this.sdk.GET(t, ...e);
    if (s.error || !s.data)
      throw new v("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePostRequest(t, ...e) {
    const s = await this.sdk.POST(t, ...e);
    if (s.error || !s.data)
      throw new v("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudGetRequest(t, ...e) {
    const s = await this.sdkCloud.GET(t, ...e);
    if (s.error || !s.data)
      throw new v("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeCloudPostRequest(t, ...e) {
    const s = await this.sdkCloud.POST(t, ...e);
    if (s.error || !s.data)
      throw new v("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePutRequest(t, ...e) {
    const s = await this.sdk.PUT(t, ...e);
    if (s.error || !s.data)
      throw new v("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makePatchRequest(t, ...e) {
    const s = await this.sdk.PATCH(t, ...e);
    if (s.error || !s.data)
      throw new v("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
  /**
   * @internal
   */
  async makeDeleteRequest(t, ...e) {
    const s = await this.sdk.DELETE(t, ...e);
    if (s.error || !s.data)
      throw new v("Request failed", {
        path: t,
        response: s,
        ...e
      });
    return s.data;
  }
}
class Vt extends re {
  /**
   * Constructs a new instance of the AppAutomateClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Retrieves the plan information for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the plan information.
   */
  getPlan(t) {
    return this.makeGetRequest("/app-automate/plan.json", t);
  }
  /**
   * Retrieves the list of devices available for App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the list of devices.
   */
  getDevices(t) {
    return this.makeGetRequest("/app-automate/devices.json", t);
  }
  /**
   * Retrieves the projects from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects.
   */
  getProjects(t) {
    return this.makeGetRequest("/app-automate/projects.json", t);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(t, e) {
    return this.makeGetRequest("/app-automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project in the App Automate API.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project data.
   */
  updateProject(t, e, s) {
    return this.makePutRequest("/app-automate/projects/{projectId}.json", {
      ...s,
      params: {
        path: {
          projectId: t
        }
      },
      body: e
    });
  }
  /**
   * Deletes a project.
   * @param projectId The ID of the project to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(t, e) {
    return this.makeDeleteRequest("/app-automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(t, e) {
    return this.makeGetRequest("/app-automate/projects/{projectId}/badge_key", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the App Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of automation builds.
   */
  getBuilds(t, e) {
    return this.makeGetRequest("/app-automate/builds.json", {
      ...e,
      params: {
        query: t
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the build information, including the build details and associated sessions.
   */
  getBuild(t, e) {
    return this.makeGetRequest("/app-automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the App Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build information.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the updated build.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(t, e, s) {
    return this.makePutRequest("/app-automate/builds/{buildId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new v(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(t, e) {
    return this.makeDeleteRequest("/app-automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/app-automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", e.file, e.filename), a;
        },
        params: {
          path: {
            buildId: t
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/app-automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", e.file, e.filename), a;
        },
        params: {
          path: {
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the session details for a given session ID.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(t, e) {
    return this.makeGetRequest("/app-automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates the status of a session in the App Automate API.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session status.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the updated automation session.
   */
  updateSessionStatus(t, e, s) {
    return this.makePutRequest("/app-automate/sessions/{sessionId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session in the App Automate API.
   * @param sessionId - The ID of the session to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(t, e) {
    return this.makeDeleteRequest("/app-automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Retrieves the session logs for a specific build and session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the session logs.
   */
  getSessionLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/logs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the device logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the device logs.
   */
  getSessionDeviceLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/devicelogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param buildId - The ID of the build.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appiumlogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the network logs for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/networklogs",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the app profiling data.
   */
  getSessionAppProfilingDataV1(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Retrieves the app profiling data for a specific session in a build.
   * @param buildId The ID of the build.
   * @param sessionId The ID of the session.
   * @param options Additional options for the API request.
   * @returns A promise that resolves with the app profiling data.
   */
  getSessionAppProfilingDataV2(t, e, s) {
    return this.makeGetRequest(
      "/app-automate/builds/{buildId}/sessions/{sessionId}/appprofiling/v2",
      {
        ...s,
        params: {
          path: {
            buildId: t,
            sessionId: e
          }
        }
      }
    );
  }
  /**
   * Uploads a media file to the App Automate API.
   *
   * @param body - The request body containing the media file to upload.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response of the API request.
   */
  uploadMediaFile(t, e) {
    return this.makePostRequest("/app-automate/upload-media", {
      ...e,
      body: t,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", t.file, t.filename), t.custom_id && s.append("custom_id", t.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the media files associated with the App Automate session.
   *
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of media files, or an empty array if no media files are found.
   */
  getMediaFiles(t) {
    return this.makeGetRequest(
      "/app-automate/recent_media_files",
      t
    ).then((e) => "message" in e ? [] : e);
  }
  /**
   * Retrieves media files by custom ID.
   * @param customId - The custom ID to filter media files.
   * @param options - Optional fetch options.
   * @returns A promise that resolves to an array of media files or an empty array if no media files are found.
   */
  getMediaFilesByCustomId(t, e) {
    return this.makeGetRequest("/app-automate/recent_media_files/{customId}", {
      ...e,
      params: {
        path: {
          customId: t
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the group's media files from the App Automate API.
   *
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves to an array of group media files, or an empty array if the response contains a "message" property.
   */
  getGroupMediaFiles(t) {
    return this.makeGetRequest(
      "/app-automate/recent_group_media",
      t
    ).then((e) => "message" in e ? [] : e);
  }
  /**
   * Deletes a media file from the app automate custom media.
   * @param mediaId The ID of the media file to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(t, e) {
    return this.makeDeleteRequest(
      "/app-automate/custom_media/delete/{mediaId}",
      {
        ...e,
        params: {
          path: {
            mediaId: t
          }
        }
      }
    );
  }
  /**
   * Uploads an Appium app to BrowserStack App Automate.
   *
   * @param body - The request body containing the app file or URL to be uploaded.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the upload request.
   */
  uploadAppiumApp(t, e) {
    return this.makePostRequest("/app-automate/upload", {
      ...e,
      body: t,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in t ? s.append("file", t.file, t.filename) : s.append("url", t.url), t.custom_id && s.append("custom_id", t.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the list of Appium apps from the App Automate API.
   *
   * @param options - Optional fetch options for customizing the request.
   * @returns A promise that resolves to an array of Appium apps, or an empty array if no apps are found.
   */
  getAppiumApps(t) {
    return this.makeGetRequest("/app-automate/recent_apps", t).then(
      (e) => "message" in e ? [] : e
    );
  }
  /**
   * Retrieves the Appium apps by custom ID.
   * @param customId The custom ID of the app.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Appium apps.
   */
  getAppiumAppsByCustomId(t, e) {
    return this.makeGetRequest("/app-automate/recent_apps/{customId}", {
      ...e,
      params: {
        path: {
          customId: t
        }
      }
    }).then((s) => "message" in s ? [] : s);
  }
  /**
   * Retrieves the list of App Automate apps for the group using the specified fetch options.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the list of group apps, or an empty array if there is a "message" property in the response data.
   */
  getAppiumGroupApps(t) {
    return this.makeGetRequest("/app-automate/recent_group_apps", t).then(
      (e) => "message" in e ? [] : e
    );
  }
  /**
   * Deletes an Appium app.
   *
   * @param appId - The ID of the app to delete.
   * @param options - Optional fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteAppiumApp(t, e) {
    return this.makeDeleteRequest("/app-automate/app/delete/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  /**
   * Uploads a Flutter app for App Automate.
   *
   * @param body - The request body containing the app file or URL and other optional parameters.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadFlutterApp(t, e, s) {
    return this.makePostRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/app" : "/app-automate/flutter-integration-tests/v2/ios/test-package",
      {
        ...s,
        body: e,
        bodySerializer: () => {
          const a = new FormData();
          return "file" in e ? a.append("file", e.file, e.filename) : a.append("url", e.url), e.custom_id && a.append("custom_id", e.custom_id), a;
        }
      }
    );
  }
  /**
   * Retrieves the list of Flutter apps for Android.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of Flutter apps, or an empty array if no apps are found.
   */
  getFlutterApps(t, e) {
    return this.makeGetRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps" : "/app-automate/flutter-integration-tests/v2/ios/test-packages",
      e
    ).then(
      (s) => "apps" in s ? s.apps : "test_packages" in s ? s.test_packages : []
    );
  }
  /**
   * Retrieves the Flutter app with the specified appId.
   * @param appId The ID of the Flutter app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Flutter app.
   */
  getFlutterApp(t, e, s) {
    return this.makeGetRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: e
          }
        }
      }
    ).then((a) => "app" in a ? a.app : a.test_package);
  }
  /**
   * Deletes a Flutter app from the BrowserStack App Automate service.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteFlutterApp(t, e, s) {
    return this.makeDeleteRequest(
      t === "android" ? "/app-automate/flutter-integration-tests/v2/android/apps/{appId}" : "/app-automate/flutter-integration-tests/v2/ios/test-package/{appId}",
      {
        ...s,
        params: {
          path: {
            appId: e
          }
        }
      }
    );
  }
  /**
   * Uploads an Espresso app to BrowserStack.
   *
   * @param body - The request body containing the app file or URL.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response from the server.
   */
  uploadEspressoApp(t, e) {
    return this.makePostRequest("/app-automate/espresso/v2/app", {
      ...e,
      body: t,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in t ? s.append("file", t.file, t.filename) : s.append("url", t.url), t.custom_id && s.append("custom_id", t.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the Espresso apps from the App Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves to an array of Espresso apps.
   */
  getEspressoApps(t) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps", t).then(
      (e) => "apps" in e ? e.apps : []
    );
  }
  /**
   * Retrieves the Espresso app with the specified appId.
   * @param appId The ID of the Espresso app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the retrieved Espresso app.
   */
  getEspressoApp(t, e) {
    return this.makeGetRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an Espresso app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is deleted.
   */
  deleteEspressoApp(t, e) {
    return this.makeDeleteRequest("/app-automate/espresso/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  /**
   * Uploads an XCUITest app to BrowserStack App Automate.
   *
   * @param body - The request body containing the XCUITest app file or URL.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the response of the request.
   */
  uploadXCUITestApp(t, e) {
    return this.makePostRequest("/app-automate/xcuitest/v2/app", {
      ...e,
      body: t,
      bodySerializer: () => {
        const s = new FormData();
        return "file" in t ? s.append("file", t.file, t.filename) : s.append("url", t.url), t.custom_id && s.append("custom_id", t.custom_id), s;
      }
    });
  }
  /**
   * Retrieves the XCUITest apps available in the BrowserStack App Automate.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to an array of XCUITest apps.
   */
  getXCUITestApps(t) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps", t).then(
      (e) => "apps" in e ? e.apps : []
    );
  }
  /**
   * Retrieves the XCUITest app with the specified appId.
   * @param appId The ID of the XCUITest app to retrieve.
   * @param options The fetch options for the request.
   * @returns A promise that resolves to the XCUITest app.
   */
  getXCUITestApp(t, e) {
    return this.makeGetRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    }).then((s) => s.app);
  }
  /**
   * Deletes an XCUITest app.
   * @param appId The ID of the app to delete.
   * @param options The fetch options for the delete request.
   * @returns A promise that resolves when the app is successfully deleted.
   */
  deleteXCUITestApp(t, e) {
    return this.makeDeleteRequest("/app-automate/xcuitest/v2/apps/{appId}", {
      ...e,
      params: {
        path: {
          appId: t
        }
      }
    });
  }
  uploadDetoxAndroidApp(t, e, s) {
    return this.makePostRequest(
      t ? "/app-automate/detox/v2/android/app" : "/app-automate/detox/v2/android/app-client",
      {
        ...s,
        body: e,
        bodySerializer: () => {
          const a = new FormData();
          return "file" in e ? a.append("file", e.file, e.filename) : a.append("url", e.url), e.custom_id && a.append("custom_id", e.custom_id), a;
        }
      }
    );
  }
}
class Xt extends re {
  /**
   * Constructs a new instance of the AutomateClient class.
   * @param options - Options to customize the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com"
    });
  }
  /**
   * Recycles the automate key.
   * @param options The fetch options for the request.
   * @returns {} A promise that resolves to the response of the request.
   */
  recycleKey(t) {
    return this.makePutRequest("/automate/recycle_key.json", t);
  }
  /**
   * Retrieves the automate plan.
   * @param options - The fetch options for the request.
   * @returns A promise that resolves with the automate plan.
   */
  getPlan(t) {
    return this.makeGetRequest("/automate/plan.json", t);
  }
  /**
   * Retrieves the list of available browsers for BrowserStack Automate.
   * @param options - Optional fetch options for customizing the request.
   * @returns A Promise that resolves to the list of available browsers.
   */
  getBrowsers(t) {
    return this.makeGetRequest("/automate/browsers.json", t);
  }
  /**
   * Retrieves the projects from the BrowserStack Automate API.
   * @param options - The fetch options for the API request.
   * @returns A promise that resolves with the projects data.
   */
  getProjects(t) {
    return this.makeGetRequest("/automate/projects.json", t);
  }
  /**
   * Retrieves a project by its ID.
   * @param projectId The ID of the project to retrieve.
   * @param options Additional options for the fetch request.
   * @returns A promise that resolves to the retrieved project.
   */
  getProject(t, e) {
    return this.makeGetRequest("/automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    }).then((s) => s.project);
  }
  /**
   * Updates a project with the specified ID.
   *
   * @param projectId - The ID of the project to update.
   * @param body - The request body containing the updated project details.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the updated project.
   */
  updateProject(t, e, s) {
    return this.makePutRequest("/automate/projects/{projectId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Deletes a project with the specified ID.
   * @param projectId The ID of the project to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the project is successfully deleted.
   */
  deleteProject(t, e) {
    return this.makeDeleteRequest("/automate/projects/{projectId}.json", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      }
    });
  }
  /**
   * Retrieves the badge key for a specific project.
   * @param projectId The ID of the project.
   * @param options Additional options for the request.
   * @returns A promise that resolves to the badge key.
   */
  getBadgeKey(t, e) {
    return this.makeGetRequest("/automate/projects/{projectId}/badge_key", {
      ...e,
      params: {
        path: {
          projectId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves a list of builds from the BrowserStack Automate API.
   *
   * @param query - Optional query parameters for filtering the builds.
   * @param options - Optional fetch options for the API request.
   * @returns A Promise that resolves to an array of automation builds.
   */
  getBuilds(t, e) {
    return this.makeGetRequest("/automate/builds.json", {
      ...e,
      params: {
        query: t
      }
    }).then((s) => s.map((a) => a.automation_build));
  }
  /**
   * Retrieves information about a specific build.
   * @param buildId - The ID of the build.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the build information.
   */
  getBuild(t, e) {
    return this.makeGetRequest("/automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((s) => ({
      ...s.build.automation_build,
      sessions: s.build.sessions.map(
        (a) => a.automation_session
      )
    }));
  }
  /**
   * Updates a build in the BrowserStack Automate API.
   *
   * @param buildId - The ID of the build to update.
   * @param body - The request body containing the updated build data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated build data.
   * @throws {BrowserStackError} If an error occurs during the update.
   */
  updateBuild(t, e, s) {
    return this.makePutRequest("/automate/builds/{buildId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          buildId: t
        }
      }
    }).then((a) => {
      if ("error" in a)
        throw new v(a.error, { response: a });
      return a.automation_build;
    });
  }
  /**
   * Deletes a build with the specified ID.
   * @param buildId The ID of the build to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the build is successfully deleted.
   */
  deleteBuild(t, e) {
    return this.makeDeleteRequest("/automate/builds/{buildId}.json", {
      ...e,
      params: {
        path: {
          buildId: t
        }
      }
    });
  }
  /**
   * Deletes multiple builds from the BrowserStack Automate API.
   * @param buildIds An array of build IDs to be deleted.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the delete request is successful.
   */
  deleteBuilds(t, e) {
    return this.makeDeleteRequest("/automate/builds", {
      ...e,
      params: {
        query: {
          "buildId[]": t
        }
      }
    });
  }
  /**
   * Retrieves the sessions associated with a specific build.
   *
   * @param buildId - The ID of the build.
   * @param query - Optional query parameters for filtering the sessions.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to an array of automation sessions.
   */
  getSessions(t, e, s) {
    return this.makeGetRequest("/automate/builds/{buildId}/sessions.json", {
      ...s,
      params: {
        path: {
          buildId: t
        },
        query: e
      }
    }).then((a) => a.map((i) => i.automation_session));
  }
  /**
   * Retrieves the details of a specific session.
   * @param sessionId - The ID of the session to retrieve.
   * @param options - Additional options for the fetch request.
   * @returns A promise that resolves to the automation session data.
   */
  getSession(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((s) => s.automation_session);
  }
  /**
   * Updates an automate session.
   *
   * @param sessionId - The ID of the session to update.
   * @param body - The request body containing the updated session data.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the updated automation session.
   */
  updateSession(t, e, s) {
    return this.makePutRequest("/automate/sessions/{sessionId}.json", {
      ...s,
      body: e,
      params: {
        path: {
          sessionId: t
        }
      }
    }).then((a) => a.automation_session);
  }
  /**
   * Deletes a session by its session ID.
   * @param sessionId The ID of the session to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the session is successfully deleted.
   */
  deleteSession(t, e) {
    return this.makeDeleteRequest("/automate/sessions/{sessionId}.json", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Deletes the specified sessions.
   * @param sessionIds - An array of session IDs to delete.
   * @param options - Additional options for the delete request.
   * @returns A promise that resolves when the delete request is complete.
   */
  deleteSessions(t, e) {
    return this.makeDeleteRequest("/automate/sessions", {
      ...e,
      params: {
        query: {
          "sessionId[]": t
        }
      }
    });
  }
  /**
   * Uploads terminal logs for a specific build.
   * @param buildId - The ID of the build.
   * @param body - The request body containing the logs file and its filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadBuildTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/automate/builds/{buildId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", e.file, e.filename), a;
        },
        params: {
          path: {
            buildId: t
          }
        }
      }
    );
  }
  /**
   * Uploads terminal logs for a session.
   * @param sessionId - The ID of the session.
   * @param body - The request body containing the logs file and filename.
   * @param options - Additional options for the request.
   * @returns A promise that resolves to the response of the request.
   */
  uploadSessionTerminalLogs(t, e, s) {
    return this.makeCloudPostRequest(
      "/automate/sessions/{sessionId}/terminallogs",
      {
        ...s,
        body: e,
        bodySerializer: () => {
          const a = new FormData();
          return a.append("file", e.file, e.filename), a;
        },
        params: {
          path: {
            sessionId: t
          }
        }
      }
    );
  }
  /**
   * Retrieves the logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A promise that resolves with the logs of the session.
   */
  getSessionLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/logs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the network logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the network logs request.
   * @returns A Promise that resolves to the network logs response.
   */
  getSessionNetworkLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/networklogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Retrieves the console logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the console logs.
   */
  getSessionConsoleLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/consolelogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the Selenium logs for a specific session.
   * @param sessionId The ID of the session.
   * @param options Additional options for the request.
   * @returns A Promise that resolves to the Selenium logs.
   */
  getSessionSeleniumLogs(t, e) {
    return this.makeCloudGetRequest(
      "/automate/sessions/{sessionId}/seleniumlogs",
      {
        ...e,
        params: {
          path: {
            sessionId: t
          }
        },
        parseAs: "text"
      }
    );
  }
  /**
   * Retrieves the Appium logs for a specific session.
   *
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves to the Appium logs.
   */
  getSessionAppiumLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/appiumlogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      },
      parseAs: "text"
    });
  }
  /**
   * Retrieves the telemetry logs for a specific session.
   * @param sessionId - The ID of the session.
   * @param options - Additional options for the request.
   * @returns A Promise that resolves with the telemetry logs.
   */
  getSessionTelemetryLogs(t, e) {
    return this.makeGetRequest("/automate/sessions/{sessionId}/telemetrylogs", {
      ...e,
      params: {
        path: {
          sessionId: t
        }
      }
    });
  }
  /**
   * Uploads a media file to the BrowserStack Automate API.
   *
   * @param body - The content of the media file to be uploaded, along with its filename.
   * @param options - Additional options for the API request.
   * @returns A Promise that resolves to the response of the API request.
   */
  uploadMediaFile(t, e) {
    return this.makePostRequest("/automate/upload-media", {
      ...e,
      body: t,
      bodySerializer: () => {
        const s = new FormData();
        return s.append("file", t.file, t.filename), s;
      }
    });
  }
  /**
   * Retrieves the recent media files from the BrowserStack Automate API.
   * @param options - Optional fetch options for the API request.
   * @returns A promise that resolves with the response from the API.
   */
  getMediaFiles(t) {
    return this.makeGetRequest("/automate/recent_media_files", t);
  }
  /**
   * Deletes a media file.
   * @param mediaId The ID of the media file to delete.
   * @param options Additional options for the delete request.
   * @returns A promise that resolves when the media file is successfully deleted.
   */
  deleteMediaFile(t, e) {
    return this.makeDeleteRequest("/automate/custom_media/delete/{mediaId}", {
      ...e,
      params: {
        path: {
          mediaId: t
        }
      }
    });
  }
}
class Ue extends re {
  /**
   * Constructs a new instance of the JSTestingClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://api.browserstack.com/5"
    });
  }
  getAccountStatus(t) {
    return this.makeGetRequest("/status", t);
  }
  /**
   * Retrieves a list of browsers from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of browsers.
   */
  getBrowsers(t, e) {
    return this.makeGetRequest("/browsers", {
      ...e,
      params: {
        query: {
          ...t,
          flat: typeof (t == null ? void 0 : t.flat) == "boolean" ? t.flat : !0
        }
      }
    });
  }
  createWorker(t, e) {
    return this.makePostRequest("/worker", {
      ...e,
      body: t
    });
  }
  getWorkers(t) {
    return this.makeGetRequest("/workers", t);
  }
  getWorker(t, e) {
    return this.makeGetRequest("/worker/{workedId}", {
      ...e,
      params: {
        path: {
          workedId: t
        }
      }
    });
  }
  deleteWorker(t, e) {
    return this.makeDeleteRequest("/worker/{workedId}", {
      ...e,
      params: {
        path: {
          workedId: t
        }
      }
    });
  }
}
var C = Uint8Array, J = Uint16Array, Jt = Int32Array, ze = new C([
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  0,
  1,
  1,
  1,
  1,
  2,
  2,
  2,
  2,
  3,
  3,
  3,
  3,
  4,
  4,
  4,
  4,
  5,
  5,
  5,
  5,
  0,
  /* unused */
  0,
  0,
  /* impossible */
  0
]), Fe = new C([
  0,
  0,
  0,
  0,
  1,
  1,
  2,
  2,
  3,
  3,
  4,
  4,
  5,
  5,
  6,
  6,
  7,
  7,
  8,
  8,
  9,
  9,
  10,
  10,
  11,
  11,
  12,
  12,
  13,
  13,
  /* unused */
  0,
  0
]), Yt = new C([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]), He = function(r, t) {
  for (var e = new J(31), s = 0; s < 31; ++s)
    e[s] = t += 1 << r[s - 1];
  for (var a = new Jt(e[30]), s = 1; s < 30; ++s)
    for (var i = e[s]; i < e[s + 1]; ++i)
      a[i] = i - e[s] << 5 | s;
  return { b: e, r: a };
}, Ke = He(ze, 2), Ne = Ke.b, Qt = Ke.r;
Ne[28] = 258, Qt[258] = 28;
var Zt = He(Fe, 0), es = Zt.b, Re = new J(32768);
for (var b = 0; b < 32768; ++b) {
  var K = (b & 43690) >> 1 | (b & 21845) << 1;
  K = (K & 52428) >> 2 | (K & 13107) << 2, K = (K & 61680) >> 4 | (K & 3855) << 4, Re[b] = ((K & 65280) >> 8 | (K & 255) << 8) >> 1;
}
var ee = function(r, t, e) {
  for (var s = r.length, a = 0, i = new J(t); a < s; ++a)
    r[a] && ++i[r[a] - 1];
  var n = new J(t);
  for (a = 1; a < t; ++a)
    n[a] = n[a - 1] + i[a - 1] << 1;
  var c;
  if (e) {
    c = new J(1 << t);
    var o = 15 - t;
    for (a = 0; a < s; ++a)
      if (r[a])
        for (var l = a << 4 | r[a], h = t - r[a], u = n[r[a] - 1]++ << h, f = u | (1 << h) - 1; u <= f; ++u)
          c[Re[u] >> o] = l;
  } else
    for (c = new J(s), a = 0; a < s; ++a)
      r[a] && (c[a] = Re[n[r[a] - 1]++] >> 15 - r[a]);
  return c;
}, ae = new C(288);
for (var b = 0; b < 144; ++b)
  ae[b] = 8;
for (var b = 144; b < 256; ++b)
  ae[b] = 9;
for (var b = 256; b < 280; ++b)
  ae[b] = 7;
for (var b = 280; b < 288; ++b)
  ae[b] = 8;
var We = new C(32);
for (var b = 0; b < 32; ++b)
  We[b] = 5;
var ts = /* @__PURE__ */ ee(ae, 9, 1), ss = /* @__PURE__ */ ee(We, 5, 1), ke = function(r) {
  for (var t = r[0], e = 1; e < r.length; ++e)
    r[e] > t && (t = r[e]);
  return t;
}, O = function(r, t, e) {
  var s = t / 8 | 0;
  return (r[s] | r[s + 1] << 8) >> (t & 7) & e;
}, ye = function(r, t) {
  var e = t / 8 | 0;
  return (r[e] | r[e + 1] << 8 | r[e + 2] << 16) >> (t & 7);
}, rs = function(r) {
  return (r + 7) / 8 | 0;
}, Ie = function(r, t, e) {
  return (t == null || t < 0) && (t = 0), (e == null || e > r.length) && (e = r.length), new C(r.subarray(t, e));
}, as = [
  "unexpected EOF",
  "invalid block type",
  "invalid length/literal",
  "invalid distance",
  "stream finished",
  "no stream handler",
  ,
  "no callback",
  "invalid UTF-8 data",
  "extra field too long",
  "date not in range 1980-2099",
  "filename too long",
  "stream finishing",
  "invalid zip data"
  // determined by unknown compression method
], G = function(r, t, e) {
  var s = new Error(t || as[r]);
  if (s.code = r, Error.captureStackTrace && Error.captureStackTrace(s, G), !e)
    throw s;
  return s;
}, is = function(r, t, e, s) {
  var a = r.length, i = s ? s.length : 0;
  if (!a || t.f && !t.l)
    return e || new C(0);
  var n = !e, c = n || t.i != 2, o = t.i;
  n && (e = new C(a * 3));
  var l = function(Te) {
    var Ge = e.length;
    if (Te > Ge) {
      var De = new C(Math.max(Ge * 2, Te));
      De.set(e), e = De;
    }
  }, h = t.f || 0, u = t.p || 0, f = t.b || 0, k = t.l, w = t.d, m = t.m, I = t.n, x = a * 8;
  do {
    if (!k) {
      h = O(r, u, 1);
      var A = O(r, u + 1, 3);
      if (u += 3, A)
        if (A == 1)
          k = ts, w = ss, m = 9, I = 5;
        else if (A == 2) {
          var j = O(r, u, 31) + 257, V = O(r, u + 10, 15) + 4, R = j + O(r, u + 5, 31) + 1;
          u += 14;
          for (var _ = new C(R), g = new C(19), p = 0; p < V; ++p)
            g[Yt[p]] = O(r, u + p * 3, 7);
          u += V * 3;
          for (var E = ke(g), z = (1 << E) - 1, Q = ee(g, E, 1), p = 0; p < R; ) {
            var ne = Q[O(r, u, z)];
            u += ne & 15;
            var S = ne >> 4;
            if (S < 16)
              _[p++] = S;
            else {
              var F = 0, oe = 0;
              for (S == 16 ? (oe = 3 + O(r, u, 3), u += 2, F = _[p - 1]) : S == 17 ? (oe = 3 + O(r, u, 7), u += 3) : S == 18 && (oe = 11 + O(r, u, 127), u += 7); oe--; )
                _[p++] = F;
            }
          }
          var Ee = _.subarray(0, j), H = _.subarray(j);
          m = ke(Ee), I = ke(H), k = ee(Ee, m, 1), w = ee(H, I, 1);
        } else
          G(1);
      else {
        var S = rs(u) + 4, y = r[S - 4] | r[S - 3] << 8, U = S + y;
        if (U > a) {
          o && G(0);
          break;
        }
        c && l(f + y), e.set(r.subarray(S, U), f), t.b = f += y, t.p = u = U * 8, t.f = h;
        continue;
      }
      if (u > x) {
        o && G(0);
        break;
      }
    }
    c && l(f + 131072);
    for (var st = (1 << m) - 1, rt = (1 << I) - 1, he = u; ; he = u) {
      var F = k[ye(r, u) & st], X = F >> 4;
      if (u += F & 15, u > x) {
        o && G(0);
        break;
      }
      if (F || G(2), X < 256)
        e[f++] = X;
      else if (X == 256) {
        he = u, k = null;
        break;
      } else {
        var _e = X - 254;
        if (X > 264) {
          var p = X - 257, Z = ze[p];
          _e = O(r, u, (1 << Z) - 1) + Ne[p], u += Z;
        }
        var me = w[ye(r, u) & rt], de = me >> 4;
        me || G(3), u += me & 15;
        var H = es[de];
        if (de > 3) {
          var Z = Fe[de];
          H += ye(r, u) & (1 << Z) - 1, u += Z;
        }
        if (u > x) {
          o && G(0);
          break;
        }
        c && l(f + 131072);
        var Pe = f + _e;
        if (f < H) {
          var Ce = i - H, at = Math.min(H, Pe);
          for (Ce + f < 0 && G(3); f < at; ++f)
            e[f] = s[Ce + f];
        }
        for (; f < Pe; ++f)
          e[f] = e[f - H];
      }
    }
    t.l = k, t.p = he, t.b = f, t.f = h, k && (h = 1, t.m = m, t.d = w, t.n = I);
  } while (!h);
  return f != e.length && n ? Ie(e, 0, f) : e.subarray(0, f);
}, ns = /* @__PURE__ */ new C(0), M = function(r, t) {
  return r[t] | r[t + 1] << 8;
}, $ = function(r, t) {
  return (r[t] | r[t + 1] << 8 | r[t + 2] << 16 | r[t + 3] << 24) >>> 0;
}, Se = function(r, t) {
  return $(r, t) + $(r, t + 4) * 4294967296;
};
function os(r, t) {
  return is(r, { i: 2 }, t && t.out, t && t.dictionary);
}
var be = typeof TextDecoder < "u" && /* @__PURE__ */ new TextDecoder(), us = 0;
try {
  be.decode(ns, { stream: !0 }), us = 1;
} catch {
}
var cs = function(r) {
  for (var t = "", e = 0; ; ) {
    var s = r[e++], a = (s > 127) + (s > 223) + (s > 239);
    if (e + a > r.length)
      return { s: t, r: Ie(r, e - 1) };
    a ? a == 3 ? (s = ((s & 15) << 18 | (r[e++] & 63) << 12 | (r[e++] & 63) << 6 | r[e++] & 63) - 65536, t += String.fromCharCode(55296 | s >> 10, 56320 | s & 1023)) : a & 1 ? t += String.fromCharCode((s & 31) << 6 | r[e++] & 63) : t += String.fromCharCode((s & 15) << 12 | (r[e++] & 63) << 6 | r[e++] & 63) : t += String.fromCharCode(s);
  }
};
function ls(r, t) {
  if (t) {
    for (var e = "", s = 0; s < r.length; s += 16384)
      e += String.fromCharCode.apply(null, r.subarray(s, s + 16384));
    return e;
  } else {
    if (be)
      return be.decode(r);
    var a = cs(r), i = a.s, e = a.r;
    return e.length && G(8), i;
  }
}
var fs = function(r, t) {
  return t + 30 + M(r, t + 26) + M(r, t + 28);
}, ps = function(r, t, e) {
  var s = M(r, t + 28), a = ls(r.subarray(t + 46, t + 46 + s), !(M(r, t + 8) & 2048)), i = t + 46 + s, n = $(r, t + 20), c = e && n == 4294967295 ? hs(r, i) : [n, $(r, t + 24), $(r, t + 42)], o = c[0], l = c[1], h = c[2];
  return [M(r, t + 10), o, l, a, i + M(r, t + 30) + M(r, t + 32), h];
}, hs = function(r, t) {
  for (; M(r, t) != 1; t += 4 + M(r, t + 2))
    ;
  return [Se(r, t + 12), Se(r, t + 4), Se(r, t + 20)];
};
function ms(r, t) {
  for (var e = {}, s = r.length - 22; $(r, s) != 101010256; --s)
    (!s || r.length - s > 65558) && G(13);
  var a = M(r, s + 8);
  if (!a)
    return {};
  var i = $(r, s + 16), n = i == 4294967295 || a == 65535;
  if (n) {
    var c = $(r, s - 12);
    n = $(r, c) == 101075792, n && (a = $(r, c + 32), i = $(r, c + 48));
  }
  for (var o = t && t.filter, l = 0; l < a; ++l) {
    var h = ps(r, i, n), u = h[0], f = h[1], k = h[2], w = h[3], m = h[4], I = h[5], x = fs(r, I);
    i = m, (!o || o({
      name: w,
      size: f,
      originalSize: k,
      compression: u
    })) && (u ? u == 8 ? e[w] = os(r.subarray(x, x + f), { out: new C(k) }) : G(14, "unknown compression type " + u) : e[w] = Ie(r, x, x + f));
  }
  return e;
}
class Ve extends re {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    super({
      ...e,
      baseUrl: (e == null ? void 0 : e.baseUrl) ?? "https://www.browserstack.com",
      usernameOptional: !0
    });
    P(this, "authToken");
    const s = (e == null ? void 0 : e.key) ?? se.BROWSERSTACK_KEY;
    if (typeof s != "string" || !s.trim().length)
      throw new v("Missing options.key");
    this.authToken = s;
  }
  /**
   * Retrieves a list of recent Local binary instances from the server.
   *
   * @param options - The fetch options for the request.
   * @returns A promise that resolves to a fetch response containing the list of active Local instances.
   */
  getBinaryInstances(e, s) {
    return this.makeGetRequest("/local/v1/list", {
      ...s,
      params: {
        query: {
          ...e,
          auth_token: this.authToken
        }
      }
    }).then((a) => a.instances);
  }
  /**
   * Retrieves details of a Local binary instance from the server.
   *
   * @param localInstanceId The ID of the local binary instance to retrieve.
   * @param query Optional query parameters for the request.
   * @param options Optional fetch options for the request.
   * @returns A promise that resolves to the retrieved local binary instance.
   * @throws {BrowserStackError} If no local binary instance is found with the specified ID.
   */
  getBinaryInstance(e, s, a) {
    return this.makeGetRequest("/local/v1/{localInstanceId}", {
      ...a,
      params: {
        path: {
          localInstanceId: e
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((i) => {
      if (!i.instances.length)
        throw new v(
          `No Local binary instance found with id "${e}"`
        );
      return i.instances[0];
    });
  }
  /**
   * Disconnects a binary instance.
   *
   * @param localInstanceId - The ID of the local binary instance to disconnect.
   * @param query - Optional query parameters for the request.
   * @param options - Optional API fetch options.
   * @returns A promise that resolves to a string representing the message from the server.
   */
  disconnectBinaryInstance(e, s, a) {
    return this.makeDeleteRequest("/local/v1/{localInstanceId}", {
      ...a,
      params: {
        path: {
          localInstanceId: e
        },
        query: {
          ...s,
          auth_token: this.authToken
        }
      }
    }).then((i) => i.message);
  }
  /**
   * Downloads the BrowserStackLocal binary for the specified operating system architecture and saves it to the specified file path.
   * Note that the file is downloaded to memory for the unzip operation.
   * If the file is large, this method may fail with an out of memory error.
   * This method is intended for use in Node.js environments and will fail in the browser.
   *
   * @internal
   * @param osArch - The operating system architecture for which to download the binary.
   * @param dirPath - The file path where the binary will be saved.
   * @param filenamePrefix - The prefix for the downloaded binary file name inside the ZIP file. Default is "BrowserStackLocal".
   * @param fileMode - The file mode to set for the downloaded binary file. Default is 0o755.
   * @param options - Additional options for the API fetch request.
   * @returns A Promise that resolves when the binary is successfully downloaded and saved.
   */
  downloadBinary(e, s = "BrowserStackLocal", a) {
    return this.sdk.GET("/browserstack-local/BrowserStackLocal-{osArch}.zip", {
      ...a,
      params: {
        path: {
          osArch: e
        }
      },
      parseAs: "arrayBuffer"
    }).then((i) => i.response.arrayBuffer()).then((i) => {
      const n = ms(new Uint8Array(i), {
        filter: (l) => l.name.startsWith(s)
      }), c = Object.keys(n);
      if (!c.length)
        throw new v(
          `Local binary not found in BrowserStackLocal-${e}.zip`
        );
      return { content: n[c[0]], filename: c[0] };
    }).catch((i) => {
      throw i instanceof v ? i : new v(
        `Failed to write local binary to disk: ${i.message}: ${i.stack}`
      );
    });
  }
}
class ds extends re {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(t) {
    super({
      ...t,
      baseUrl: (t == null ? void 0 : t.baseUrl) ?? "https://www.browserstack.com"
    });
  }
  /**
   * Retrieves the list of available browsers for taking screenshots.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getBrowsers(t) {
    return this.makeGetRequest("/screenshots/browsers.json", t);
  }
  /**
   * Creates a new screenshots job.
   * @param body - The request body for creating the job.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  createJob(t, e) {
    return this.makePostRequest("/screenshots", {
      ...e,
      body: t
    });
  }
  /**
   * Retrieves the details of a screenshots job.
   * @param jobId - The ID of the job to retrieve.
   * @param options - Optional fetch options for the request.
   * @returns A promise that resolves to the response from the API.
   */
  getJob(t, e) {
    return this.makeGetRequest("/screenshots/{jobId}.json", {
      ...e,
      params: {
        path: {
          jobId: t
        }
      }
    });
  }
}
const gs = {
  AutomateClient: Xt,
  ScreenshotsClient: ds,
  AppAutomateClient: Vt,
  JSTestingClient: Ue,
  /**
   * Backwards compatibility alias for {@link JSTestingClient}.
   */
  Client: Ue,
  LocalTestingClient: Ve
};
function ws(r) {
  return r && r.__esModule && Object.prototype.hasOwnProperty.call(r, "default") ? r.default : r;
}
var ie = { exports: {} }, Xe = { exports: {} };
/**
 * @preserve
 * JS Implementation of incremental MurmurHash3 (r150) (as of May 10, 2013)
 *
 * @author <a href="mailto:jensyt@gmail.com">Jens Taylor</a>
 * @see http://github.com/homebrewing/brauhaus-diff
 * @author <a href="mailto:gary.court@gmail.com">Gary Court</a>
 * @see http://github.com/garycourt/murmurhash-js
 * @author <a href="mailto:aappleby@gmail.com">Austin Appleby</a>
 * @see http://sites.google.com/site/murmurhash/
 */
(function(r) {
  (function() {
    var t;
    function e(s, a) {
      var i = this instanceof e ? this : t;
      if (i.reset(a), typeof s == "string" && s.length > 0 && i.hash(s), i !== this)
        return i;
    }
    e.prototype.hash = function(s) {
      var a, i, n, c, o;
      switch (o = s.length, this.len += o, i = this.k1, n = 0, this.rem) {
        case 0:
          i ^= o > n ? s.charCodeAt(n++) & 65535 : 0;
        case 1:
          i ^= o > n ? (s.charCodeAt(n++) & 65535) << 8 : 0;
        case 2:
          i ^= o > n ? (s.charCodeAt(n++) & 65535) << 16 : 0;
        case 3:
          i ^= o > n ? (s.charCodeAt(n) & 255) << 24 : 0, i ^= o > n ? (s.charCodeAt(n++) & 65280) >> 8 : 0;
      }
      if (this.rem = o + this.rem & 3, o -= this.rem, o > 0) {
        for (a = this.h1; i = i * 11601 + (i & 65535) * 3432906752 & 4294967295, i = i << 15 | i >>> 17, i = i * 13715 + (i & 65535) * 461832192 & 4294967295, a ^= i, a = a << 13 | a >>> 19, a = a * 5 + 3864292196 & 4294967295, !(n >= o); )
          i = s.charCodeAt(n++) & 65535 ^ (s.charCodeAt(n++) & 65535) << 8 ^ (s.charCodeAt(n++) & 65535) << 16, c = s.charCodeAt(n++), i ^= (c & 255) << 24 ^ (c & 65280) >> 8;
        switch (i = 0, this.rem) {
          case 3:
            i ^= (s.charCodeAt(n + 2) & 65535) << 16;
          case 2:
            i ^= (s.charCodeAt(n + 1) & 65535) << 8;
          case 1:
            i ^= s.charCodeAt(n) & 65535;
        }
        this.h1 = a;
      }
      return this.k1 = i, this;
    }, e.prototype.result = function() {
      var s, a;
      return s = this.k1, a = this.h1, s > 0 && (s = s * 11601 + (s & 65535) * 3432906752 & 4294967295, s = s << 15 | s >>> 17, s = s * 13715 + (s & 65535) * 461832192 & 4294967295, a ^= s), a ^= this.len, a ^= a >>> 16, a = a * 51819 + (a & 65535) * 2246770688 & 4294967295, a ^= a >>> 13, a = a * 44597 + (a & 65535) * 3266445312 & 4294967295, a ^= a >>> 16, a >>> 0;
    }, e.prototype.reset = function(s) {
      return this.h1 = typeof s == "number" ? s : 0, this.rem = this.k1 = this.len = 0, this;
    }, t = new e(), r.exports = e;
  })();
})(Xe);
var vs = Xe.exports, Je = {}, Ye = {};
(function(r) {
  Object.defineProperty(r, "__esModule", { value: !0 }), r.signals = void 0, r.signals = [], r.signals.push("SIGHUP", "SIGINT", "SIGTERM"), process.platform !== "win32" && r.signals.push(
    "SIGALRM",
    "SIGABRT",
    "SIGVTALRM",
    "SIGXCPU",
    "SIGXFSZ",
    "SIGUSR2",
    "SIGTRAP",
    "SIGSYS",
    "SIGQUIT",
    "SIGIOT"
    // should detect profiler and enable/disable accordingly.
    // see #21
    // 'SIGPROF'
  ), process.platform === "linux" && r.signals.push("SIGIO", "SIGPOLL", "SIGPWR", "SIGSTKFLT");
})(Ye);
(function(r) {
  var k, w, m, I, x, A, S, y, Qe, j, Ze;
  var t;
  Object.defineProperty(r, "__esModule", { value: !0 }), r.unload = r.load = r.onExit = r.signals = void 0;
  const e = Ye;
  Object.defineProperty(r, "signals", { enumerable: !0, get: function() {
    return e.signals;
  } });
  const s = (R) => !!R && typeof R == "object" && typeof R.removeListener == "function" && typeof R.emit == "function" && typeof R.reallyExit == "function" && typeof R.listeners == "function" && typeof R.kill == "function" && typeof R.pid == "number" && typeof R.on == "function", a = Symbol.for("signal-exit emitter"), i = globalThis, n = Object.defineProperty.bind(Object);
  class c {
    constructor() {
      P(this, "emitted", {
        afterExit: !1,
        exit: !1
      });
      P(this, "listeners", {
        afterExit: [],
        exit: []
      });
      P(this, "count", 0);
      P(this, "id", Math.random());
      if (i[a])
        return i[a];
      n(i, a, {
        value: this,
        writable: !1,
        enumerable: !1,
        configurable: !1
      });
    }
    on(_, g) {
      this.listeners[_].push(g);
    }
    removeListener(_, g) {
      const p = this.listeners[_], E = p.indexOf(g);
      E !== -1 && (E === 0 && p.length === 1 ? p.length = 0 : p.splice(E, 1));
    }
    emit(_, g, p) {
      if (this.emitted[_])
        return !1;
      this.emitted[_] = !0;
      let E = !1;
      for (const z of this.listeners[_])
        E = z(g, p) === !0 || E;
      return _ === "exit" && (E = this.emit("afterExit", g, p) || E), E;
    }
  }
  class o {
  }
  const l = (R) => ({
    onExit(_, g) {
      return R.onExit(_, g);
    },
    load() {
      return R.load();
    },
    unload() {
      return R.unload();
    }
  });
  class h extends o {
    onExit() {
      return () => {
      };
    }
    load() {
    }
    unload() {
    }
  }
  class u extends o {
    constructor(g) {
      super();
      L(this, y);
      L(this, j);
      // "SIGHUP" throws an `ENOSYS` error on Windows,
      // so use a supported signal instead
      /* c8 ignore start */
      L(this, k, f.platform === "win32" ? "SIGINT" : "SIGHUP");
      /* c8 ignore stop */
      L(this, w, new c());
      L(this, m, void 0);
      L(this, I, void 0);
      L(this, x, void 0);
      L(this, A, {});
      L(this, S, !1);
      W(this, m, g), W(this, A, {});
      for (const p of e.signals)
        d(this, A)[p] = () => {
          const E = d(this, m).listeners(p);
          let { count: z } = d(this, w);
          const Q = g;
          if (typeof Q.__signal_exit_emitter__ == "object" && typeof Q.__signal_exit_emitter__.count == "number" && (z += Q.__signal_exit_emitter__.count), E.length === z) {
            this.unload();
            const ne = d(this, w).emit("exit", null, p), F = p === "SIGHUP" ? d(this, k) : p;
            ne || g.kill(g.pid, F);
          }
        };
      W(this, x, g.reallyExit), W(this, I, g.emit);
    }
    onExit(g, p) {
      if (!s(d(this, m)))
        return () => {
        };
      d(this, S) === !1 && this.load();
      const E = p != null && p.alwaysLast ? "afterExit" : "exit";
      return d(this, w).on(E, g), () => {
        d(this, w).removeListener(E, g), d(this, w).listeners.exit.length === 0 && d(this, w).listeners.afterExit.length === 0 && this.unload();
      };
    }
    load() {
      if (!d(this, S)) {
        W(this, S, !0), d(this, w).count += 1;
        for (const g of e.signals)
          try {
            const p = d(this, A)[g];
            p && d(this, m).on(g, p);
          } catch {
          }
        d(this, m).emit = (g, ...p) => we(this, j, Ze).call(this, g, ...p), d(this, m).reallyExit = (g) => we(this, y, Qe).call(this, g);
      }
    }
    unload() {
      d(this, S) && (W(this, S, !1), e.signals.forEach((g) => {
        const p = d(this, A)[g];
        if (!p)
          throw new Error("Listener not defined for signal: " + g);
        try {
          d(this, m).removeListener(g, p);
        } catch {
        }
      }), d(this, m).emit = d(this, I), d(this, m).reallyExit = d(this, x), d(this, w).count -= 1);
    }
  }
  k = new WeakMap(), w = new WeakMap(), m = new WeakMap(), I = new WeakMap(), x = new WeakMap(), A = new WeakMap(), S = new WeakMap(), y = new WeakSet(), Qe = function(g) {
    return s(d(this, m)) ? (d(this, m).exitCode = g || 0, d(this, w).emit("exit", d(this, m).exitCode, null), d(this, x).call(d(this, m), d(this, m).exitCode)) : 0;
  }, j = new WeakSet(), Ze = function(g, ...p) {
    const E = d(this, I);
    if (g === "exit" && s(d(this, m))) {
      typeof p[0] == "number" && (d(this, m).exitCode = p[0]);
      const z = E.call(d(this, m), g, ...p);
      return d(this, w).emit("exit", d(this, m).exitCode, null), z;
    } else
      return E.call(d(this, m), g, ...p);
  };
  const f = globalThis.process;
  t = l(s(f) ? new u(f) : new h()), /**
   * Called when the process is exiting, whether via signal, explicit
   * exit, or running out of stuff to do.
   *
   * If the global process object is not suitable for instrumentation,
   * then this will be a no-op.
   *
   * Returns a function that may be used to unload signal-exit.
   */
  r.onExit = t.onExit, /**
   * Load the listeners.  Likely you never need to call this, unless
   * doing a rather deep integration with signal-exit functionality.
   * Mostly exposed for the benefit of testing.
   *
   * @internal
   */
  r.load = t.load, /**
   * Unload the listeners.  Likely you never need to call this, unless
   * doing a rather deep integration with signal-exit functionality.
   * Mostly exposed for the benefit of testing.
   *
   * @internal
   */
  r.unload = t.unload;
})(Je);
ie.exports = Is;
ie.exports.sync = qs;
ie.exports._getTmpname = qe;
ie.exports._cleanupOnExit = Ae;
const q = ft, ks = vs, { onExit: et } = Je, ys = pt, { promisify: T } = ht, N = {}, Ss = function() {
  try {
    return require("worker_threads").threadId;
  } catch {
    return 0;
  }
}();
let xs = 0;
function qe(r) {
  return r + "." + ks(__filename).hash(String(process.pid)).hash(String(Ss)).hash(String(++xs)).result();
}
function Ae(r) {
  return () => {
    try {
      q.unlinkSync(typeof r == "function" ? r() : r);
    } catch {
    }
  };
}
function Rs(r) {
  return new Promise((t) => {
    N[r] || (N[r] = []), N[r].push(t), N[r].length === 1 && t();
  });
}
function pe(r) {
  return r.code === "ENOSYS" || (!process.getuid || process.getuid() !== 0) && (r.code === "EINVAL" || r.code === "EPERM");
}
async function bs(r, t, e = {}) {
  typeof e == "string" && (e = { encoding: e });
  let s, a;
  const i = et(Ae(() => a)), n = ys.resolve(r);
  try {
    await Rs(n);
    const c = await T(q.realpath)(r).catch(() => r);
    if (a = qe(c), !e.mode || !e.chown) {
      const o = await T(q.stat)(c).catch(() => {
      });
      o && (e.mode == null && (e.mode = o.mode), e.chown == null && process.getuid && (e.chown = { uid: o.uid, gid: o.gid }));
    }
    s = await T(q.open)(a, "w", e.mode), e.tmpfileCreated && await e.tmpfileCreated(a), ArrayBuffer.isView(t) ? await T(q.write)(s, t, 0, t.length, 0) : t != null && await T(q.write)(s, String(t), 0, String(e.encoding || "utf8")), e.fsync !== !1 && await T(q.fsync)(s), await T(q.close)(s), s = null, e.chown && await T(q.chown)(a, e.chown.uid, e.chown.gid).catch((o) => {
      if (!pe(o))
        throw o;
    }), e.mode && await T(q.chmod)(a, e.mode).catch((o) => {
      if (!pe(o))
        throw o;
    }), await T(q.rename)(a, c);
  } finally {
    s && await T(q.close)(s).catch(
      /* istanbul ignore next */
      () => {
      }
    ), i(), await T(q.unlink)(a).catch(() => {
    }), N[n].shift(), N[n].length > 0 ? N[n][0]() : delete N[n];
  }
}
async function Is(r, t, e, s) {
  e instanceof Function && (s = e, e = {});
  const a = bs(r, t, e);
  if (s)
    try {
      const i = await a;
      return s(i);
    } catch (i) {
      return s(i);
    }
  return a;
}
function qs(r, t, e) {
  typeof e == "string" ? e = { encoding: e } : e || (e = {});
  try {
    r = q.realpathSync(r);
  } catch {
  }
  const s = qe(r);
  if (!e.mode || !e.chown)
    try {
      const o = q.statSync(r);
      e = Object.assign({}, e), e.mode || (e.mode = o.mode), !e.chown && process.getuid && (e.chown = { uid: o.uid, gid: o.gid });
    } catch {
    }
  let a;
  const i = Ae(s), n = et(i);
  let c = !0;
  try {
    if (a = q.openSync(s, "w", e.mode || 438), e.tmpfileCreated && e.tmpfileCreated(s), ArrayBuffer.isView(t) ? q.writeSync(a, t, 0, t.length, 0) : t != null && q.writeSync(a, String(t), 0, String(e.encoding || "utf8")), e.fsync !== !1 && q.fsyncSync(a), q.closeSync(a), a = null, e.chown)
      try {
        q.chownSync(s, e.chown.uid, e.chown.gid);
      } catch (o) {
        if (!pe(o))
          throw o;
      }
    if (e.mode)
      try {
        q.chmodSync(s, e.mode);
      } catch (o) {
        if (!pe(o))
          throw o;
      }
    q.renameSync(s, r), c = !1;
  } finally {
    if (a)
      try {
        q.closeSync(a);
      } catch {
      }
    n(), c && i();
  }
}
var As = ie.exports;
const js = /* @__PURE__ */ ws(As);
async function Es(r, t = "BrowserStackLocal") {
  const e = await Ps(r), a = await tt() === "win32" ? `${t}.exe` : t, i = Le(e, a);
  if (!await fe(i, Y.R_OK | Y.X_OK))
    throw new v(`Missing or inaccessible file: ${i}`);
  return i;
}
async function fe(r, t = Y.R_OK) {
  if (typeof r != "string" || !r.trim().length)
    return !1;
  const e = await te(r).catch(
    (a) => a.code === "ENOENT" ? null : a
  ), s = t & 448;
  return !(!e || !e.isFile() || e.mode & s);
}
async function _s(r, t = Y.R_OK) {
  if (typeof r != "string" || !r.trim().length)
    return !1;
  const e = await te(r).catch(
    (a) => a.code === "ENOENT" ? null : a
  ), s = t & 448;
  return !(!e || !e.isDirectory() || e.mode & s);
}
async function Ps(r, t = 493, e) {
  try {
    const s = Me(r), a = await te(s).catch(async (n) => {
      if (n.code === "ENOENT")
        return await ut(s, { recursive: !0, mode: t }), te(s);
      throw n;
    }), i = (e ?? Y.R_OK | Y.W_OK) & 448;
    return a && a.mode & i && await ct(s, t), s;
  } catch (s) {
    throw s instanceof Error ? new v(
      `Missing or inaccessible directory: ${r}`,
      s
    ) : s;
  }
}
async function tt() {
  if (["x64", "ia32"].includes(ue))
    switch (Oe) {
      case "darwin":
        if (ue === "x64")
          return "darwin-x64";
        break;
      case "win32":
      case "cygwin":
        return "win32";
      case "linux":
        if (ue === "ia32")
          return "linux-ia32";
        try {
          if (ot("ldd", ["--version"]).stderr.toString("utf8").indexOf("musl") !== -1)
            return "alpine";
        } catch {
        }
        return "linux-x64";
    }
  throw new v(
    `Unsupported platform/arch: ${Oe}/${ue}`
  );
}
async function Cs(r, t, e, s) {
  const a = Le(Me(r), t);
  try {
    return await js(a, Buffer.from(e), { mode: s }), a;
  } catch (i) {
    try {
      (await te(a)).isFile() && await lt(a);
    } catch {
    }
    throw i;
  }
}
class je extends Ve {
  /**
   * Constructs a new instance of the ScreenshotsClient class.
   * @param options - Optional configuration options for the client.
   */
  constructor(e) {
    var a, i;
    super(e);
    P(this, "localIdentifier");
    P(this, "child", {
      pid: void 0,
      args: []
    });
    P(this, "commandTimeoutMs");
    P(this, "binHome");
    /**
     * The last state of the BrowserStackLocal daemon command.
     * @public
     */
    P(this, "state", "stopped");
    this.options = e;
    const s = (e == null ? void 0 : e.localIdentifier) ?? ((i = (a = se.BROWSERSTACK_LOCAL_ID) == null ? void 0 : a.trim) == null ? void 0 : i.call(a)) ?? mt(16).toString("hex");
    if (typeof s != "string" || !s.trim().length)
      throw new v("Missing options.localIdentifier.id");
    this.localIdentifier = s, this.commandTimeoutMs = (e == null ? void 0 : e.commandTimeoutMs) ?? 1e4, this.binHome = this.getBinHome();
  }
  /**
   * Retrieves the version of the local testing binary.
   * @returns A promise that resolves to the version string.
   */
  async version() {
    const e = await this.ensureBinaryExists();
    return new Promise((s, a) => {
      var l, h, u, f, k, w, m, I, x, A;
      const i = Be.spawnSync(e, ["--version"], {
        timeout: this.commandTimeoutMs,
        cwd: this.binHome,
        windowsHide: !0
      }), n = (f = (u = (h = (l = i.stdout) == null ? void 0 : l.toString) == null ? void 0 : h.call(l, "utf8")) == null ? void 0 : u.trim) == null ? void 0 : f.call(u), c = (w = (k = n == null ? void 0 : n.match(/\s+version\s+(.*)$/i)) == null ? void 0 : k[1]) == null ? void 0 : w.trim();
      if (typeof c == "string")
        return s(c);
      const o = (A = (x = (I = (m = i.stderr) == null ? void 0 : m.toString) == null ? void 0 : I.call(m, "utf8")) == null ? void 0 : x.trim) == null ? void 0 : A.call(x);
      a(
        new v(
          `Failed to get version: ${o ?? n} (status=${i.status})`
        )
      );
    });
  }
  /**
   * Starts the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the binary starts successfully, or undefined if there is an error.
   */
  async start() {
    let e;
    return await this.runDaemonCommand({
      action: "start",
      initialState: "starting",
      successState: "started",
      isSuccess: (s, a, i) => {
        const n = a === "connected";
        return e ?? (e = i), n;
      }
    }).catch((s) => {
      throw e && Object.assign(s, { message: e }), s;
    }), e;
  }
  /**
   * Stops the BrowserStackLocal daemon.
   *
   * @returns A promise that resolves to a string if the daemon stops successfully, or undefined otherwise.
   */
  async stop() {
    let e;
    return await this.runDaemonCommand({
      action: "stop",
      initialState: "stopping",
      successState: "stopped",
      isSuccess: (s, a, i) => {
        var c, o, l;
        return e ?? (e = i), a === "success" && ((l = (o = (c = i == null ? void 0 : i.toLowerCase) == null ? void 0 : c.call(i)) == null ? void 0 : o.includes) == null ? void 0 : l.call(o, "stopped successfully")) === !0;
      }
    }).catch((s) => {
      throw e && Object.assign(s, { message: e }), s;
    }), e;
  }
  /**
   * @internal
   */
  async runDaemonCommand(e, s = this.commandTimeoutMs, a = this.binHome) {
    const i = {
      state: this.state,
      pid: this.child.pid,
      args: this.child.args
    }, n = (l) => {
      throw this.state = i.state, this.child.pid = i.pid, this.child.args = i.args, l;
    }, c = await this.ensureBinaryExists().catch(n), o = await je.resolveArgs(
      this.authToken,
      this.localIdentifier,
      e.action,
      this.options
    );
    return new Promise((l, h) => {
      var w, m, I, x, A, S, y, U;
      this.state = e.initialState;
      const u = Be.spawnSync(c, o, {
        timeout: s,
        cwd: a,
        windowsHide: !0
      });
      if (u.error)
        return h(new v(u.error.message, u.error));
      const f = (x = (I = (m = (w = u.stdout) == null ? void 0 : w.toString) == null ? void 0 : m.call(w, "utf8")) == null ? void 0 : I.trim) == null ? void 0 : x.call(I);
      if (f)
        try {
          const j = JSON.parse(f);
          if (j && typeof j == "object") {
            const { state: V, message: R } = this.parseOutput(j);
            if (e.isSuccess(j, V, R))
              return this.state = e.successState, e.action === "start" ? (this.child.pid = j.pid ?? u.pid, this.child.args = o.slice(2)) : e.action === "stop" && (this.child.pid = void 0, this.child.args = []), l();
          }
        } catch {
        }
      const k = (U = (y = (S = (A = u.stderr) == null ? void 0 : A.toString) == null ? void 0 : S.call(A, "utf8")) == null ? void 0 : y.trim) == null ? void 0 : U.call(y);
      if (k)
        try {
          const j = JSON.parse(k);
          if (j && typeof j == "object") {
            const { state: V, message: R } = this.parseOutput(j);
            if (R)
              return h(new v(`${R} state=${V}`));
          }
        } catch {
        }
      return h(new v(k ?? f));
    }).catch(n);
  }
  /**
   * @internal
   */
  static async resolveArgs(e, s, a, i) {
    if (typeof e != "string" || !e.trim().length)
      throw new v("Required: key");
    if (typeof s != "string" || !s.trim().length)
      throw new v("Required: localIdentifier");
    const n = [
      "--key",
      e.trim(),
      "--local-identifier",
      s.trim(),
      "--daemon",
      a
    ];
    if (!i)
      return n;
    const c = async ({ rootCA: l }) => {
      l && "useSystem" in l && l.useSystem === !0 && n.push("--use-system-installed-ca"), l && "path" in l && l.path && await fe(l.path) && n.push("--use-ca-certificate", l.path);
    };
    if ((i == null ? void 0 : i.disableAPILogging) !== !0 && n.push("--enable-logging-for-api"), i.forceLocal === !0)
      n.push("--force-local");
    else if (i.only) {
      const l = i.only.map(
        ({ host: h, port: u, ssl: f }) => `${h},${u},${f ? 1 : 0}`
      );
      n.push("--only", l.join(","));
    }
    if ("folder" in i && await _s(i.folder))
      n.push("--folder", i.folder);
    else if ("localProxy" in i && i.localProxy) {
      const {
        host: l,
        port: h,
        auth: { username: u, password: f } = {
          username: void 0,
          password: void 0
        }
      } = i.localProxy;
      n.push("--local-proxy-host", l.trim()), h && n.push("--local-proxy-port", `${h}`), u && f && (n.push("--local-proxy-user", u.trim()), n.push("--local-proxy-pass", f.trim())), await c(i.localProxy);
    }
    const o = i == null ? void 0 : i.proxy;
    if (o)
      if (typeof o == "string")
        if (await fe(o))
          n.push("--proxy-pac", o);
        else
          throw new v(`Invalid proxy pac file: ${o}`);
      else {
        const {
          host: l,
          port: h,
          auth: { username: u, password: f } = {
            username: void 0,
            password: void 0
          },
          force: k
        } = o;
        n.push("--proxy-host", l.trim()), h && n.push("--proxy-port", `${h}`), u && f && (n.push("--proxy-user", u.trim()), n.push("--proxy-pass", f.trim())), k && n.push("--force-proxy"), await c(o);
      }
    if (i.onlyAutomate === !0 && n.push("--only-automate"), i.debug) {
      const { level: l, logFile: h } = i.debug;
      l && n.push("--verbose", `${l}`), h && n.push("--log-file", h);
    }
    if (i.timeout && n.push("--timeout", `${i.timeout}`), i.parallelRuns && n.push("--parallel-runs", `${i.parallelRuns}`), i.hosts) {
      const { include: l, exclude: h } = i.hosts;
      Array.isArray(l) && l.length && n.push("--include-hosts", ...l), Array.isArray(h) && h.length && n.push("--exclude-hosts", ...h);
    }
    return n.concat(i.more ?? []);
  }
  get pid() {
    var e;
    return (e = this.child) == null ? void 0 : e.pid;
  }
  get args() {
    var e, s;
    return (e = this.child) != null && e.args ? Array.from((s = this.child) == null ? void 0 : s.args) : [];
  }
  /**
   * @internal
   */
  parseOutput(e) {
    let s, a, i;
    return typeof e.status == "string" && (s = e.status.trim()), typeof e.state == "string" && (s = e.state.trim()), typeof e.pid == "string" && (a = e.pid.trim()), "message" in e && e.message && (typeof e.message == "string" ? i = e.message.trim() : typeof e.message == "object" && (i = "message" in e.message && typeof e.message.message == "string" ? e.message.message.trim() : void 0)), { state: s, pid: a, message: i };
  }
  /**
   * @internal
   */
  getBinHome() {
    var s;
    const e = ((s = this.options) == null ? void 0 : s.binHome) ?? se.BROWSERSTACK_LOCAL_BINARY_PATH;
    if (typeof e != "string" || !e.trim().length)
      throw new v("Missing options.binHome");
    return e.trim();
  }
  /**
   * @internal
   */
  async ensureBinaryExists() {
    try {
      const s = await Es(this.binHome);
      if (await fe(s))
        return s;
    } catch {
    }
    const e = await tt();
    if (!e)
      throw new v(`Unsupported platform: ${e}`);
    try {
      const { content: s, filename: a } = await this.downloadBinary(e);
      return await Cs(this.binHome, a, s, 493);
    } catch (s) {
      throw s instanceof v ? s : s instanceof Error ? new v(
        `Failed to download binary: ${s.message}`,
        s
      ) : new v(`Failed to download binary: ${s}`);
    }
  }
}
const Ms = {
  ...gs,
  LocalTestingBinary: je
};
export {
  Ms as B,
  v as a,
  se as b,
  Ps as e,
  js as w
};
